abuild.in 45.4 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
8
# Depends on: busybox utilities, fakeroot
Natanael Copa's avatar
Natanael Copa committed
9 10
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
FAKEROOT=${FAKEROOT:-"fakeroot"}
22

23 24
: ${SUDO_APK:=abuild-apk}
: ${APK:=apk}
25 26 27
: ${ADDUSER:=abuild-adduser}
: ${ADDGROUP:=abuild-addgroup}

28
apk_opt_wait="--wait 30"
29

Natanael Copa's avatar
Natanael Copa committed
30
# read config
Natanael Copa's avatar
Natanael Copa committed
31
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
32 33
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

34
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
35 36 37 38 39 40
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
41 42 43 44 45 46 47 48 49 50 51 52 53 54
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
55 56 57 58 59 60 61
fi

# run optional log command for remote logging
logcmd() {
	${ABUILD_LOG_CMD:-true} "$@"
	return 0
}
Natanael Copa's avatar
Natanael Copa committed
62 63 64

# functions
msg() {
65
	[ -n "$quiet" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
66 67 68
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
69 70 71 72 73 74 75
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

msg2() {
	[ -n "$quiet" ] && return 0
	#      ">>> %s"
	printf "    %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
76 77 78 79 80 81
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
82 83 84 85 86 87
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

warning2() {
	#      ">>> WARNING: 
	printf "             %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
88 89 90 91 92 93
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
94
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
95
	logcmd "ERROR: $pkgname: $1"
96 97 98 99 100
}

error2() {
	#      ">>> ERROR: 
	printf "           %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
101
}
102

Linux User's avatar
Linux User committed
103
set_xterm_title() {
104
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
105
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
106 107 108 109 110
	fi
} 

cleanup() {
	set_xterm_title ""
111
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
112
		msg "Uninstalling dependencies..."
113
		$SUDO_APK del --quiet $apk_opt_wait $uninstall_after
114
	fi
115 116 117
	if [ -n "$CLEANUP_FILES" ]; then
		rm -f $CLEANUP_FILES
	fi
Linux User's avatar
Linux User committed
118 119
}

Natanael Copa's avatar
Natanael Copa committed
120
die() {
Linux User's avatar
Linux User committed
121
	error "$@"
Linux User's avatar
Linux User committed
122
	cleanup
Natanael Copa's avatar
Natanael Copa committed
123 124 125
	exit 1
}

126 127 128 129
spell_error() {
	die "APKBUILD contains '$1'. It should be '$2'"
}

130
# check if apkbuild is basicly sane
131
default_sanitycheck() {
132
	local i= j= suggestion=
133
	msg "Checking sanity of $APKBUILD..."
134 135 136
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
137
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
138
		$APK version --check -q "$pkgver" ||\
139 140
			die "$pkgver is not a valid version"
	fi
141
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
142 143 144
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"
145 146 147
	if [ $(echo "$pkgdesc" | wc -c) -gt 128 ]; then
		die "pkgdesc is too long"
	fi
148

149 150
	if [ -n "$replaces_priority" ] \
		&& ! echo $replaces_priority | egrep -q '^[0-9]+$'; then
151 152
		die "replaces_priority must be a number"
	fi
153 154 155 156 157 158 159
	# check so no package names starts with -
	for i in $pkgname $subpackages; do
		case $i in
		-*) die "${i%:*} is not a valid package name";;
		esac
	done

160 161 162 163 164 165 166 167 168 169
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
170
	for i in $install; do
171
		local n=${i%.*}
172
		local suff=${i##*.}
173 174 175 176 177
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
178
			die "$i: install script does not match pkgname or any subpackage"
179
		fi
180
		[ -e "$startdir/$i" ] || die "install script $i is missing"
181 182 183 184 185 186
		for j in chown chmod chgrp; do
			if grep -q $j "$startdir"/$i; then
				warning "$i: found $j"
				warning2 "Permissions should be fixed in APKBUILD package()"
			fi
		done
Natanael Copa's avatar
Natanael Copa committed
187
	done
188

189 190 191 192 193 194 195 196
	for i in $triggers; do
		local f=${i%=*}
		local p=${f%.trigger}
		[ "$f" = "$i" ] && die "$f: triggers must contain '='" 
		[ "$p" = "$f" ] && die "$f: triggers scripts must have .trigger suffix"
		if ! subpackages_has "$p" && [ "$p" != "$pkgname" ]; then
			die "$p: trigger script does not match pkgname or any subpackage"
		fi
Natanael Copa's avatar
Natanael Copa committed
197

198 199
		[ -e "$startdir"/$f ] || die "trigger script $f is missing"
	done
200 201
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
202 203 204 205
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
206
			case "$i" in
207
				*::*) i=${i%%::*};;
208
				https://*) makedepends_has wget && warning "wget no longer need to be in makedepends when source has https://" ;;
209
			esac
210 211
			list_has ${i##*/} $md5sums $sha256sums $sha512sums \
				|| die "${i##*/} is missing in checksums"
212 213
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
214

215 216 217 218 219 220 221 222
	# verify that things listed in checksum also is listed in source
	local algo=
	for algo in md5 sha256 sha512; do
		eval set -- \$${algo}sums
		while [ $# -gt 1 ]; do
			local file="$2"
			shift 2
			source_has $file || die "$file exists in ${algo}sums but is missing in source"
223
		done
224
	done
225

226
	# common spelling errors
227 228 229 230 231
	[ -n "$depend" ] && spell_error depend depends
	[ -n "$makedepend" ] && spell_error makedepend makedepends
	[ -n "$pkguser" ] && spell_error pkguser pkgusers
	[ -n "$pkggroup" ] && spell_error pkggroup pkggroups
	[ -n "$subpackage" ] && spell_error subpackage subpackages
Natanael Copa's avatar
Natanael Copa committed
232 233

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
234 235

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
236 237 238
	return 0
}

239 240 241 242
sanitycheck() {
	default_sanitycheck
}

243 244
sumcheck() {
	local algo="$1" sums="$2"
245
	local dummy f endreturnval originalparams origin file
246 247 248 249 250 251 252 253

	# get number of checksums
	set -- $sums
	local numsums=$(( $# / 2 ))

	set -- $source
	if [ $# -ne $numsums ]; then
		die "Number of ${algo}sums($numsums) does not correspond to number of sources($#)"
254
	fi
255
	fetch || return 1
256
	msg "Checking ${algo}sums..."
Natanael Copa's avatar
Natanael Copa committed
257
	cd "$srcdir" || return 1
258 259
	IFS=$'\n'
	endreturnval=0
260
	for src in $sums; do
261
		origin=$1; shift
262
		echo "$src" | ${algo}sum -c
263
		if [ $? -ne 0 ]; then
264
			endreturnval=1
265
			is_remote $origin || continue
266
			echo "Because the remote file above failed the ${algo}sum check it will be deleted."
267 268 269 270 271 272 273 274
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
275 276
}

277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300
# for compatibility
md5check() {
	warning "'md5check' is deprecated. Use 'verify' instead"
	sumcheck md5 "$md5sums"
}

# verify checksums
verify() {
	local verified=false algo=
	for algo in md5 sha1 sha256 sha512; do
		local sums=
		eval sums=\"\$${algo}sums\"
		if [ -z "$sums" ] || [ -z "$source" ]; then
			continue
		fi
		sumcheck "$algo" "$sums" || return 1
		verified=true
	done
	if [ -n "$source" ] && ! $verified; then
		die "Use 'abuild checksum' to generate/update the checksum(s)"
	fi
	return 0
}

301 302
# verify upstream sources
sourcecheck() {
303 304 305 306 307 308 309 310
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
311 312 313
		*::*)
			uri=${uri##*::}
			;;
314 315
		esac
		wget -q -s "$uri" || return 1
316
	done
317
	return 0
318
}
319

320 321 322
# convert curl options to wget options and call wget instead of curl
wget_fallback() {
	local wget_opts= outfile= opt=
323
	while getopts "C:Lko:s" opt; do
324
		case $opt in
325
		'L') ;; # --location. wget does this by default
326
		'f') ;; # --fail. wget does this by default
327 328 329 330 331 332 333 334 335 336
		'C') wget_opts="$wget_opts -c";; # --continue-at
		's') wget_opts="$wget_opts -q";; # --silent
		'o') wget_opts="$wget_opts -O $OPTARG";; # --output
		'k') wget_opts="$wget_opts --no-check-certificate";; #gnu wget
		esac
	done
	shift $(( $OPTIND - 1 ))
	wget $wget_opts "$1"
}

Natanael Copa's avatar
Natanael Copa committed
337 338
uri_fetch() {
	local uri="$1"
339
	local d="${uri##*/}"	# $(basename $uri)
340
	local opts
341
	[ -n "$quiet" ] && opts="-s"
342 343

	local lockfile="$SRCDEST/$d".lock
344

345 346 347 348 349
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
350 351 352 353 354

		*::*)
			d=${uri%%::*}
			uri=${uri#$d::}
			;;
355
	esac
356 357

	case "$uri" in
358
		https://*) opts="-k";;
359
	esac
360

Natanael Copa's avatar
Natanael Copa committed
361
	mkdir -p "$SRCDEST"
362 363 364

	CLEANUP_FILES="$CLEANUP_FILES $lockfile"
	(
365 366
	flock -n -x 9 || msg "Waiting for ${lockfile##*/}..."
	flock -x 9
367 368 369

	[ -f "$SRCDEST/$d" ] && exit 0 # use exit since its a subshell

370 371
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
372
		opts="$opts -C -"
Natanael Copa's avatar
Natanael Copa committed
373
	fi
Linux User's avatar
Linux User committed
374
	msg "Fetching $uri"
375 376

	# fallback to wget if curl is missing. useful for bootstrapping
377
	local fetcher=
378 379
	if ! [ -x "$(which curl)" ]; then
		fetcher=wget_fallback
380 381
	else
		fetcher=curl
382
		opts="$opts -L -f -k"
383 384 385
	fi

	$fetcher $opts -o "$SRCDEST/$d.part" "$uri" \
386
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
387

388
	) 9>$lockfile
389 390 391 392

	local rc=$?
	rm -f "$lockfile"
	return $rc
Natanael Copa's avatar
Natanael Copa committed
393 394
}

395
is_remote() {
396
	case "${1#*::}" in
397
		http://*|ftp://*|https://*|saveas-*://*)
398 399 400 401 402
			return 0;;
	esac
	return 1
}

403 404 405 406 407 408 409 410 411
filename_from_uri() {
	local uri="$1"
	local filename="${uri##*/}"  # $(basename $uri)
	case "$uri" in
	*::*) filename=${uri%%::*};;
	esac
	echo "$filename"
}

412 413 414 415
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	if [ -n "$DISTFILES_MIRROR" ]; then
416
		if is_remote "$DISTFILES_MIRROR"; then
417 418
			uri_fetch "$DISTFILES_MIRROR"/$(filename_from_uri $uri)\
				&& return 0
419
		else
420 421
			cp "$DISTFILES_MIRROR"/$(filename_from_uri $uri) \
				"$SRCDEST" && return 0
422
		fi
423 424 425 426
	fi
	uri_fetch "$uri"
}

427
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
428 429
	local s
	mkdir -p "$srcdir"
430 431
	for s in $source; do
		if is_remote "$s"; then
432
			uri_fetch_mirror "$s" || return 1
433
			ln -sf "$SRCDEST/$(filename_from_uri $s)" "$srcdir"/
434 435 436
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
437 438 439
	done
}

440 441 442 443
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
444 445 446 447 448 449 450 451 452 453 454 455 456 457 458
# verify that all init.d scripts are openrc runscripts
initdcheck() {
	local i
	for i in $source; do
		case $i in
		*.initd)
			head -n 1 "$srcdir"/$i | grep -q '/sbin/runscript' \
				&& continue
			error "$i is not an openrc #!/sbin/runscript"
			return 1
			;;
		esac
	done			
}

Natanael Copa's avatar
Natanael Copa committed
459
# unpack the sources
460
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
461
	local u
462
	if [ -z "$force" ]; then
463
		verify || return 1
Natanael Copa's avatar
Natanael Copa committed
464
		initdcheck || return 1
465
	fi
Natanael Copa's avatar
Natanael Copa committed
466 467
	mkdir -p "$srcdir"
	for u in $source; do
468
		local s="$SRCDEST/$(filename_from_uri $u)"
Natanael Copa's avatar
Natanael Copa committed
469
		case "$s" in
470 471 472
			*.tar)
				msg "Unpacking $s..."
				tar -C "$srcdir" -xf "$s" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
473
			*.tar.gz|*.tgz)
474
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
475 476
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
477
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
478
				tar -C "$srcdir" -jxf "$s" || return 1;;
479 480 481 482
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
483 484 485
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
486 487 488
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
489 490 491 492
		esac
	done
}

493 494 495 496
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
497 498
# cleanup source and package dir
clean() {
499
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
500
	rm -rf "$srcdir"
501
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
502 503 504 505 506 507
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
508
		if is_remote "$s"; then
509 510 511
			s=$(filename_from_uri $s)
			msg "Cleaning downloaded $s ..."
			rm -f "$SRCDEST/$s"
512
		fi
Natanael Copa's avatar
Natanael Copa committed
513 514 515
	done
}

516 517 518 519 520 521 522 523 524 525
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
526 527
cleanpkg() {
	local i
528
	getpkgver || return 1
529
	msg "Cleaning built packages..."
530
	for i in $(listpkgnames); do
531 532
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
533
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
534
	done
535
	# remove given packages from index
536
	update_abuildrepo_index
Natanael Copa's avatar
Natanael Copa committed
537 538
}

539 540 541
# clean all packages except current
cleanoldpkg() {
	local i j
542
	getpkgver || return 1
543
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
544
	for i in $(listpkgnames); do
545 546 547 548 549
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
550 551 552 553
		done
	done
	return 0
}
554 555 556

mkusers() {
	local i
557 558 559 560 561 562
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$ADDGROUP -S $i || return 1
		fi
	done
563 564
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
565
			local gopt=
566
			msg "Creating user $i"
567 568 569
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
570
			$ADDUSER -S -D -H $gopt $i || return 1
571 572 573 574 575
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
576 577
runpart() {
	local part=$1
578
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
579 580 581 582
	$part || die "$part failed"
}

# override those in your build script
583 584 585 586 587 588 589 590
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
591 592 593 594
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
595
build() {
596
	:
Natanael Copa's avatar
Natanael Copa committed
597 598
}

599 600 601
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
602
	mkdir -p "$PKGDEST"
603 604 605
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

606 607 608 609 610 611 612 613 614
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

615 616 617
postcheck() {
	local dir="$1" name="$2" i=
	msg "Running postcheck for $name"
618
	# checking for FHS compat
Natanael Copa's avatar
Natanael Copa committed
619 620 621 622 623 624 625 626
	if ! options_has "!fhs"; then
		for i in "$dir"/srv/* "$dir"/usr/local/* "$dir"/opt/*; do
			if [ -e "$i" ]; then
				error "Packages must not put anything under /srv, /usr/local or /opt"
				return 1
			fi
		done
	fi
627 628 629 630 631 632 633 634 635 636 637 638 639
	# look for *.la files
	i=$(find "$dir" -name '*.la' | sed "s|^$dir|\t|")
	if [ -n "$i" ] && ! options_has "libtool"; then
		error "Libtool archives (*.la) files found and \$options has no 'libtool' flag:"
		echo "$i"
		return 1
	fi
	# check directory permissions
	i=$(find "$dir" -type d -perm -777 | sed "s|^$dir|\t|")
	if [ -n "$i" ]; then
		warning "World writeable directories found:"
		echo "$i"
	fi
640 641 642 643 644 645 646 647 648
	# check so we dont have any suid root binaries that are not 
	i=$(find "$dir" -type f -perm +6000 \
		| xargs scanelf --nobanner --etype ET_EXEC \
		| sed "s|ET_EXEC $dir|\t|")
	if [ -n "$i" ]; then
		error "Found non-PIE files that has SUID:"
		echo "$i"
		return 1
	fi
649 650 651 652 653 654 655 656 657
	# test for textrels
	if ! options_has "textrels"; then
		local res="$(scanelf --recursive --textrel --quiet "$dir")"
		if [ -n "$res" ]; then
			error "Found textrels:"
			echo "$res"
			return 1
		fi
	fi
658 659 660
	return 0
}

661
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
662 663
	local i
	cd "$startdir"
664
	for i in $subpackages; do
665 666
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
667
		msg "Running split function $func..."
668
		local dir="$pkgbasedir/${i%:*}" name="${i%:*}"
669 670 671
		( subpkgdir="$dir" subpkgname="$name" \
			$0 $func prepare_package \
			&& postcheck "$dir" "$name" ) || return 1
Natanael Copa's avatar
Natanael Copa committed
672
	done
673
	postcheck "$pkgdir" "$pkgname" || return 1
674 675
	# post check for /usr/share/locale
	if [ -d "$pkgdir"/usr/share/locale ]; then
676
		warning "Found /usr/share/locale"
677
		warning2 "Maybe add \$pkgname-lang to subpackages?"
678
	fi
Natanael Copa's avatar
Natanael Copa committed
679 680
}

681
default_lang() {
682
	pkgdesc="Languages for package $pkgname"
683 684 685 686 687 688 689 690 691 692 693 694 695
	install_if="$pkgname=$pkgver-r$pkgrel lang"
	arch="noarch"
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/${dir%/*}
		mv "$pkgdir"/"$dir" "$subpkgdir"/"$dir" || return 1
	done
}

lang() {
	default_lang
}

696
default_lang_subpkg() {
697 698 699 700
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
701
	pkgdesc="$pkgname language pack for $lang"
702 703
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
704 705 706 707 708
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/$dir
		mv "$pkgdir"/$dir/$lang* \
		"$subpkgdir"/$dir/ \
709
		|| return 1
710 711 712 713 714
	done
}

lang_subpkg() {
	default_lang_subpkg
715 716 717 718 719 720 721 722 723 724 725
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

726 727 728 729 730 731 732 733 734 735 736 737
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

738 739 740 741 742 743
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
	fi
}

744
prepare_metafiles() {
745
	getpkgver || return 1
746 747
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
748
	local dir=${subpkgdir:-$pkgdir}
749
	local pkg="$name-$pkgver-r$pkgrel.apk"
750
	local pkginfo="$controldir"/.PKGINFO
751
	local sub
Natanael Copa's avatar
Natanael Copa committed
752 753 754
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
755
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
756 757
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
758
	local parch="$CARCH"
759 760 761 762 763

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
764

765
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
766
	if [ -n "$FAKEROOTKEY" ]; then
767
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
768
	fi
769 770
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
771
pkgname = $name
772
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
773 774 775 776 777
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
778
arch = $parch
779
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
780
EOF
781 782
	local i deps
	deps="$depends"
783
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
784 785
		for i in $install $triggers; do
			local s=${i%=*}
786
			[ "$name" != "${s%.*}" ] && continue
787
			if head -n 1 "$startdir/$s" | grep '^#!/bin/sh' >/dev/null ; then
788 789 790 791 792
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
793 794
	fi
	
795 796 797 798 799 800 801 802 803 804
	local last_commit="$(git_last_commit)$(git_dirty)"
	if [ -n "$last_commit" ]; then
		echo "commit = $last_commit" >> "$pkginfo"
	fi

	get_maintainer
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

805
	if [ -n "$replaces_priority" ]; then
806
		echo "replaces_priority = $replaces_priority" >> "$pkginfo"
807 808
	fi

Natanael Copa's avatar
Natanael Copa committed
809
	for i in $license; do
810
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
811 812
	done
	for i in $replaces; do
813
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
814
	done
815
	for i in $deps; do
816
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
817 818
	done
	for i in $conflicts; do
819
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
820 821
	done
	for i in $provides; do
822
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
823
	done
824 825 826 827 828 829
	for i in $triggers; do
		local f=${i%=*}
		local dirs=${i#*=}
		[ "${f%.trigger}" != "$name" ] && continue
		echo "triggers = ${dirs//:/ }" >> "$pkginfo"
	done
830 831 832
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
833 834

	local metafiles=".PKGINFO"
835 836 837
	for i in $install $triggers; do
		local f=${i%=*}
		local n=${f%.*}
838
		if [ "$n" != "$name" ]; then
839 840
			continue
		fi
841
		script=${f#$name}
842
		msg "Adding $script"
843
		cp "$startdir/$f" "$controldir/$script" || return 1
844
		chmod +x "$controldir/$script"
845 846
		metafiles="$metafiles $script"
	done
847
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
848
}
849

850 851
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
852
	local etype= soname= file= sover=
853
	[ "$arch" = "noarch" ] && return 0
854
	options_has "!tracedeps" && return 0
855
	# lets tell all the places we should look for .so files - all rpaths
856 857
	scanelf --quiet --recursive --rpath "$dir" \
		| sed -e 's/[[:space:]].*//' -e 's/:/\n/' | sort -u \
858
		>"$controldir"/.rpaths
859 860 861 862 863 864 865
	if grep -q -x '/usr/lib' "$controldir"/.rpaths; then
		warning "Redundat /usr/lib in rpath found"
	fi
	if grep '^/home/' "$controldir"/.rpaths; then
		error "Has /home/... in rpath"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
866 867
}

868 869 870 871 872 873 874 875 876 877 878 879
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

880 881 882 883 884
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

885 886 887 888 889 890 891
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
892 893 894
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
895 896 897 898
	fi
	return 0
}

899
prepare_package() {
900
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
901
	stripbin
902 903
	prepare_metafiles && prepare_tracedeps || return 1
	archcheck	
904 905 906 907 908 909 910 911
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

912 913 914 915 916 917 918 919 920 921 922 923 924 925 926 927 928 929 930 931 932 933 934
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

935 936 937 938
subpkg_provides() {
	grep -q -w "^$1" "$pkgbasedir"/.control.*/.provides-so 2>/dev/null
}

939 940 941
trace_apk_deps() {
	local name="$1"
	local dir="$2"
942
	local i= found= autodeps= deppkgs= missing=
943
	msg "Tracing dependencies..."
944 945 946
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
947
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
948 949 950 951
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
952
	if [ -f "$dir"/.needs-so ] && grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
953 954
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
955
		msg "  added libgcc (due to libpthread)"
956
	fi
957
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
958 959 960
		# first check if its provided by same apkbuild
		grep -q -w "^$i" "$dir"/.provides-so 2>/dev/null && continue

961 962
		if subpkg_provides "$i" || [ "$CBUILD" != "$CHOST" ] \
				|| $APK info --quiet --installed "so:$i"; then
963
			autodeps="$autodeps so:$i"
964
		else
965
			missing="$missing $i"
966
		fi
967 968 969
	done

	# find all packages that holds the so files
970
	if [ -f "$dir"/.rpaths ]; then
971 972
		local so_files=$(find_so_files "$dir"/.rpaths $missing) \
			|| return 1
973 974 975
		deppkgs=$($APK info -q -W $so_files) || return 1
	fi

976
	for found in $deppkgs; do
977
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
978 979 980
			warning "You can remove '$found' from depends"
			continue
		fi
981
		autodeps="$autodeps $found"
982
	done
983

984
	echo "# automatically detected:" >> "$dir"/.PKGINFO
985
	if [ -f "$dir"/.provides-so ]; then
986
		sed 's/^\(.*\) \([0-9].*\)/provides = so:\1=\2/' "$dir"/.provides-so \
987
			>> "$dir"/.PKGINFO
988 989
	fi
	[ -z "$autodeps" ] && return 0
990
	for i in $autodeps; do
991 992
		echo "depend = $i"
	done | sort -u >> "$dir"/.PKGINFO
993 994
	# display all depends
	sed -n '/^depend =/s/depend = /\t/p' "$dir"/.PKGINFO >&2
995 996
}

997
find_scanelf_paths() {
998
	local datadir="$1"
Natanael Copa's avatar
Natanael Copa committed
999
	local paths="$datadir/lib:$datadir/usr/lib" i= rpaths=
1000
	if [ -n "$ldpath" ]; then
1001
		paths="$paths:$(echo "$ldpath" | sed "s|\(^\|:\)|\1$datadir|g")"
1002 1003
	fi
	# search in all rpaths
Natanael Copa's avatar
Natanael Copa committed
1004 1005
	for rpaths in "$pkgbasedir"/.control.*/.rpaths; do
		[ -f "$rpaths" ] || continue
1006
		while read i; do
1007 1008 1009 1010
			local dir="${datadir}${i}"
			IFS=:
			if [ -d "$dir" ] && ! list_has "$dir" $paths; then
				paths="$paths:${dir}"
1011
			fi
1012
			unset IFS
Natanael Copa's avatar
Natanael Copa committed
1013
		done < "$rpaths"
1014 1015 1016 1017 1018 1019
	done
	echo "$paths"
}

scan_shared_objects() {
	local name="$1" controldir="$2" datadir="$3"
1020
	local opt=
1021 1022 1023

	# allow spaces in paths
	IFS=:
1024
	set -- $(find_scanelf_paths "$datadir")
1025 1026
	unset IFS

1027 1028 1029
	if options_has "ldpath-recursive"; then
		opt="--recursive"
	fi
1030 1031
	msg "Scanning shared objects"
	# lets tell all the .so files this package provides in .provides-so
1032
	scanelf --nobanner --soname $opt "$@" | while read etype soname file; do
1033 1034
		# if soname field is missing, soname will be the filepath
		sover=0
1035 1036
		if [ -z "$file" ]; then
			file="$soname"
1037
			soname=${soname##*/}
1038 1039 1040 1041
		fi

		# we only want shared libs
		case $soname in
1042
		*.so|*.so.[0-9]*|*.c32);;
1043 1044 1045 1046 1047 1048 1049 1050 1051
		*) continue;;
		esac

		case "$file" in
		*.so.[0-9]*) sover=${file##*.so.};;
		*.so)
			# filter out sonames with version when file does not
			# have version
			case "$soname" in
1052 1053 1054 1055
			*.so.[0-9]*)
				if options_has "sover-namecheck"; then
					continue
				fi
1056 1057 1058
			esac
			;;
		esac
Natanael Copa's avatar
Natanael Copa committed
1059
		list_has "$soname" $somask && continue
1060
		echo "$soname $sover"
1061 1062 1063 1064 1065 1066 1067 1068 1069 1070
	# use awk to filter out dupes that has sover = 0
	done | awk '{ if (so[$1] == 0) so[$1] = $2; }
		END { for (i in so) print(i " " so[i]); }' \
		| sort -u > "$controldir"/.provides-so

	# verify that we dont have any duplicates
	local dupes="$(cut -d' ' -f1 "$controldir"/.provides-so | uniq -d)"
	if [ -n "$dupes" ]; then
		die  "provides multiple versions of same shared object: $dupes"
	fi
1071 1072 1073 1074 1075

	# now find the so dependencies
	scanelf --nobanner --recursive --needed "$datadir"  | tr ' ' ':' \
		| awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
		| sed 's:,:\n:g' | sort -u \
Natanael Copa's avatar
Natanael Copa committed
1076
	| while read soname; do
1077
		# only add files that are not self provided
Natanael Copa's avatar
Natanael Copa committed
1078 1079 1080
		grep -q -w "^$soname" "$controldir"/.provides-so \
			|| list_has "$soname" $somask \
			|| echo $soname
1081 1082 1083
	done > "$controldir"/.needs-so
}

1084 1085 1086 1087 1088 1089 1090 1091
# read size in bytes from stdin and show as human readable
human_size() {
	awk '{  split("B KB MB GB TB PB", type)
		for(i=5; y < 1; i--)
			y = $1 / (2**(10*i))
		printf("%.1f %s\n", y, type[i+2]) }'
}

1092
create_apks() {
1093
	local file= dir= name= ver= apk= datadir= size=
1094
	getpkgver || return 1
Natanael Copa's avatar
Natanael Copa committed
1095
	mkdir -p "$PKGDEST"
1096 1097 1098 1099 1100 1101 1102 1103 1104
	if [ "$arch" != "noarch" ] && ! options_has "!tracedeps"; then
		for file in "$pkgbasedir"/.control.*/.PKGINFO; do
			dir="${file%/.PKGINFO}"
			name="$(pkginfo_val pkgname $file)"
			datadir="$pkgbasedir"/$name
			subpkgname=$name
			scan_shared_objects "$name" "$dir" "$datadir"
		done
	fi
1105
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
1106 1107 1108
		dir="${file%/.PKGINFO}"
		name=$(pkginfo_val pkgname $file)
		ver=$(pkginfo_val pkgver $file)
1109
		size=$(pkginfo_val size $file | human_size)
1110 1111 1112
		apk=$name-$ver.apk
		datadir="$pkgbasedir"/$name
		subpkgname=$name
1113 1114

		trace_apk_deps "$name" "$dir" || return 1
1115
		msg "Package size: ${size}"
1116
		msg "Compressing data..."
1117
		(
1118 1119
		cd "$datadir"
		# data.tar.gz
1120 1121 1122 1123 1124 1125
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
1126

1127
		msg "Create checksum..."
1128 1129 1130 1131 1132
		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
1133
		cd "$dir"
1134 1135
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
1136
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
1137

1138
		msg "Create $apk"
1139 1140
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
1141
		)
1142
	done
1143
	subpkgname=
Natanael Copa's avatar